//
//  MIRecordPreviewController.h
//  Montage
//
//  Created by Alex Curylo on Mon Mar 18 2002.
//  Copyright (c) 2002 Arboretum. All rights reserved.
//

#ifndef ZzTypes_h
#include "ZzTypes.h"
#endif //ZzTypes_h

#import <AppKit/AppKit.h>
#import "MIApplicationController.h"

class ArmeDataFileRef;

@interface MIRecordPreviewController : NSWindowController
{
    IBOutlet id 		fSequenceGrabberView;
    IBOutlet id 		fDevicePopup;
    //IBOutlet id 		fSGVUMeter;
    IBOutlet id 		fDeviceControlCheckbox;

	// note in 2002-04-16-recording_specs.pdf,
	// should be CoreAudio vumeters and enabling checkboxes here?

    SeqGrabComponent	fSequenceGrabber;
    SGChannel 			fSGVideoChannel;
    SGChannel 			fSGAudioChannel;
    UserData 			fSGSettings;
    Rect				fNativeSize;
	
	ComponentInstance	fDVCamera;
	QTAtomSpec			fCameraConfig;
	BOOL				fControllingCamera;

    BOOL				fRecording;
    FSSpec 				fCaptureFile;
	ArmeDataFileRef* 	fMovieFileRef;
    NSTimer				*fTimer;
}

+ (MIRecordPreviewController*) sharedRecordPreviewController;
- (MIRecordPreviewController*) init;
- (void)openSeqGrabComponent;
- (void)openCameraComponent;
- (void)openChannels;

- (void)show;
- (void)checkDevices;
- (void)updateDeviceMenu;

- (void)windowWillClose:(NSNotification *)aNotification;
- (void)closeSeqGrabComponent;
- (void)closeCameraComponent;
- (void)dealloc;

- (void)startIdling;
- (void)stopIdling;
- (void)idleSG:(NSTimer*)theTimer;

- (IBAction)deviceNone:(id)sender;
- (IBAction)deviceFromMenu:(id)sender;
- (IBAction)videoSettings:(id)sender;
- (IBAction)toggleCameraControl:(id)sender;

// not used in 2002-04-16-recording_specs.pdf
- (IBAction)audioSettings:(id)sender;
- (IBAction)record:(id)sender;

- (BOOL)isRecording;
- (void)startRecording;
- (void)stopRecording;

- (BOOL)isDeviceControllable;
- (void)devicePlay;
- (void)deviceStop;
- (void)devicePause;
- (void)deviceFastForward;
- (void)deviceRewind;
- (void)deviceFastForwardPlay;
- (void)deviceRewindPlay;
- (void)deviceSlowForward;
- (void)deviceSlowRewind;
- (void)deviceNextFrame;
- (void)devicePreviousFrame;
- (void)deviceControl:(int)opcode1 kind:(int)opcode2;

@end
